define([
    "dojo/_base/declare",
    "thornberry/app/Component/_Component",
    "dijit/_TemplatedMixin",
    "thornberry/app/Component/_DataFormMixin",
    "dojo/text!./Templates/RecordDetail.html",
    "dojo/dom-style"
],function(
    declare,
    _Component,
    _TemplatedMixin,
    _DataFormMixin,
    template,
    domStyle
) {
    return declare([_Component,_TemplatedMixin,_DataFormMixin], {
        templateString: template,

        refreshRendering: function() {
            var t = this;
            if (t.props.value && t.props.value !== t.value) {
                t.set("value",t.props.value);

                domStyle.set(t.messageContainer,"display",t.props.value.Message ? "" : "none");
                domStyle.set(t.submittedDataContainer,"display",t.props.value["Data Submitted"] ? "" : "none");
                
                var isRejected = t.props.value.Status !== "Accepted";
                domStyle.set(t.severityNode,"color",isRejected ? "red" : "");
                domStyle.set(t.messageContainer,"color",isRejected ? "red" : "");
            }
        }
    });
});