define([
    "dojo/_base/declare",
    "thornberry/app/Component/_EditorComponent",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "thornberry/app/Component/_DataFormMixin",
    "thornberry/app/Component/_TableFieldEditorMixin",
    "dojo/_base/lang",
    "dojo/text!./Templates/StatusEditor.html",
    "thornberry/app/utils",
    "dijit/form/DateTextBox",
    "dijit/form/Form",
    "dijit/form/Select"
],function(
    declare,
    _EditorComponent,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    _DataFormMixin,
    _TableFieldEditorMixin,
    lang,
    template,
    utils
) {
    return declare([_EditorComponent,_TemplatedMixin,_WidgetsInTemplateMixin,_DataFormMixin,_TableFieldEditorMixin], {
        templateString: template,

        buildRendering: function() {
            var t = this;
            t.inherited(arguments);
 
            t.setTable("status",[
                { "id": "Accepted", "name": "Accepted" },
                { "id": "Rejected", "name": "Rejected" },
                { "id": "Pending",  "name": "Pending" },
                { "id": "N/A", 		"name": "N/A" }
            ]);

            // general logic
            t.addLogic("acceptanceStatus",function(name,value) {
                t.setFormValue("acceptanceDate",null);
                if (value === "Accepted" && t.value.exportDate == "") {
                    utils.showMessage("Warning: Assessment has not been exported");
                }
            });

            // disable logic
            t.addDisabled("acceptanceDate",function(name,data) {return data.acceptanceStatus !== "Accepted";});

            // requirement logic
            t.addRequirement(null,true); // All fields required
        }
    });
});